%% firing rates as a function fo exc_ratio

% Need to run on orchestra

% cd('/groups/kreiman/joe/stdp/layers3_2015_05_19_EXC/results_3')
% Firing Rates were calculated on a computer cluster orchestra with the
% following code
% 
% alltypes = get_best_16;
% exc_ratio = (0.07:0.08:1.11);
% simnums = (6:10);
% 
% Firing_Rates = zeros(size(alltypes,1),length(simnums),length(exc_ratio),3);
% 
% for i = 1:size(alltypes,1);
%     for j = 1:length(simnums);
%         for exc = 1:length(exc_ratio);
%             load(['STDP_3layers_',num2str(alltypes(i,:),'%1d'),'_e2_e1=',num2str(exc_ratio(exc)),'_e3_e1=',num2str(exc_ratio(exc)),'_sim',num2str(simnums(j)),'.mat']);
%             time = (500000:600000);
%             Gamma = [gamma1;gamma2;gamma3];
%             Firing_Rates(i,j,exc,:) = sum(Gamma(:,time),2)/10;
%             clearvars -except alltypes exc_ratio simnums Firing_Rates i j exc
%         end
%     end
%     display(i)
% end;
% clear i j exc
% 
% save('Firing_Rates.mat','-v7.3')



%% To be run locally
addpath(genpath('..'));
% load and average the data
load('Firing_Rates.mat')
avg_firing_rate = zeros(length(exc_ratio),3);
std_firing_rate = zeros(length(exc_ratio),3);
for exc = 1:length(exc_ratio)
    for layer = 1:3
        temp = Firing_Rates(:,:,exc,layer);
        temp = temp(:);
        avg_firing_rate(exc,layer) = mean(temp);
        std_firing_rate(exc,layer) = std(temp);
    end
end

%% Figure S3c
list = winter(3);
figure()
for i = 1:3
   errorbar(exc_ratio, avg_firing_rate(:,i), std_firing_rate(:,i),'col',list(i,:),'LineWidth',2) 
   hold on
end
legend('layer 4','layer 2/3','layer 5/6')
xlabel('Exc Ratio (E4 \ E23 = E4 \ E56)')
ylabel('average firing rates')
set(gca,'FontSize',16);
ylim([0 120])

