% orchestra has stored on it data from all 512 simulations with weights
% saved over time. This data was also used to make figure for convergence.
% This data is left on orchestra because it is 500 GB in total. The folder
% in orchestra where the data is stored is called '/groups/kreiman/joe/stdp/layers3_2017_02_27_layers/results'

addpath(genpath('/groups/kreiman/joe/stdp/layers3_2017_02_27_layers/results'));

alltypes = get_alltypes;
sim = (1:5);
layer = [1:33;34:66;67:99];
weights_mean = zeros(size(alltypes,1),3,3);
weights_std = zeros(size(alltypes,1),3,3);
weights_mean_per_sim = zeros(size(alltypes,1),3,3,length(sim));
for i = 1:size(alltypes,1)
    temp_weights_last_5_avg = zeros(99,99,length(sim));
    for j = 1:length(sim)
        load([num2str(alltypes(i,1)),num2str(alltypes(i,2)),num2str(alltypes(i,3)),num2str(alltypes(i,4)),num2str(alltypes(i,5)),num2str(alltypes(i,6)),num2str(alltypes(i,7)),num2str(alltypes(i,8)),num2str(alltypes(i,9)),'_sim',num2str(sim(j)),'.mat'])
        temp_weights_last_5_avg(:,:,j) = squeeze(nanmean(weights(:,:,(55/60)*size(weights,3):size(weights,3)),3)); % avg over last 5 seconds
        clearvars -except i j alltypes sim layer temp_weights_last_5_avg weights_mean weights_std weights_mean_per_sim
    end
    for q1=1:3
        for q2=1:3
            temp = temp_weights_last_5_avg(layer(q1,:),layer(q2,:),:);
            weights_mean(i,q1,q2) = nanmean(temp(:));
            weights_std(i,q1,q2) = nanstd(temp(:));
            for j = 1:length(sim)
                temp2 = temp_weights_last_5_avg(layer(q1,:),layer(q2,:),j);
                weights_mean_per_sim(i,q1,q2,j) = nanmean(temp2(:));
            end; clear temp2
        end
    end; clear q1 q2 temp
    display(i)
end

cd('/groups/kreiman/joe/stdp/weight_table')
success_per_sim = zeros(size(alltypes,1),length(sim));
success_mean = zeros(size(alltypes,1),1);
success_std = zeros(size(alltypes,1),1);
for i = 1:size(alltypes,1)
    for j = 1:length(sim)
        success_per_sim(i,j) = success(squeeze(weights_mean_per_sim(i,:,:,j)));
    end
    success_mean(i) = nanmean(success_per_sim(i,:));
    success_std(i) = nanstd(success_per_sim(i,:));
end

% sort the matrices
[success_mean_sorted, ord] = sort(success_mean);
success_mean_sorted = flip(success_mean_sorted); ord = flip(ord);
success_std_sorted = success_std(ord);
weights_mean_sorted = weights_mean(ord,:,:);
weights_std_sorted = weights_std(ord,:,:);
% re-order the weight matrices
weights_mean_sorted_reshaped = zeros(size(weights_mean_sorted,1),size(weights_mean_sorted,2)*size(weights_mean_sorted,3));
weights_std_sorted_reshaped = zeros(size(weights_std_sorted,1),size(weights_std_sorted,2)*size(weights_std_sorted,3));
for i = 1:size(weights_std_sorted,1)
    temp1 = squeeze(weights_mean_sorted(i,:,:));
    weights_mean_sorted_reshaped(i,:) = reshape(temp1',1,9);
    temp2 = squeeze(weights_std_sorted(i,:,:));
    weights_std_sorted_reshaped(i,:) = reshape(temp2',1,9);
    clear temp1 temp2
end

alltypes_sorted = alltypes(ord,:);

%% make one big table

intra_weights = [2,3,4,6,7,8];
Table = {};
for i = 1:16
    Table{i,1}=i;
    for j = 1:6
        Table{i,j+1} = sprintf(['%.2f ',177,' %.2f'],weights_mean_sorted_reshaped(i,intra_weights(j)),weights_std_sorted_reshaped(i,intra_weights(j)));
    end
    Table{i,8} = sprintf(['%.2f ',177,' %.2f'],success_mean_sorted(i),success_std_sorted(i));
end
for i = 1:16
    Table{16+i,1}=240+i;
    for j = 1:6
        Table{16+i,j+1} = sprintf(['%.2f ',177,' %.2f'],weights_mean_sorted_reshaped(240+i,intra_weights(j)),weights_std_sorted_reshaped(240+i,intra_weights(j)));
    end
    Table{16+i,8} = sprintf(['%.2f ',177,' %.2f'],success_mean_sorted(240+i),success_std_sorted(240+i));
end
for i = 1:16
    Table{32+i,1}=496+i;
    for j = 1:6
        Table{32+i,j+1} = sprintf(['%.2f ',177,' %.2f'],weights_mean_sorted_reshaped(496+i,intra_weights(j)),weights_std_sorted_reshaped(496+i,intra_weights(j)));
    end
    Table{32+i,8} = sprintf(['%.2f ',177,' %.2f'],success_mean_sorted(496+i),success_std_sorted(496+i));
end
test=cell2table(Table);
writetable(test);

%%

save(['weight_table.mat'],'-v7.3');




















